/*	
 *	clipspr.h
 *
 *	ȈՃXvCghCo`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sat Apr 24 06:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_SPR_H__
#define __CLIP_SPR_H__

/*****************************************************************************
 *	
 *****************************************************************************/

typedef struct _SPRITE {
	unsigned char texno;	/* +0,1: eNX`ԍ */
	unsigned char x, y;	/* +1,2: W       */
	unsigned char w, h;	/* +3,2: A       */
	         char cx, cy;	/* +5,2: _ItZbg */
	unsigned char param;	/* +7,1: pceLCDSetObject()paramƓł */
} SPRITE;			/* =8 */

/* XvCgԍ錾pBenum̒ŎgĂB */
#define SPRITE_INIT1(name,texno,x,y,w,h,cx,cy,param) name,

/* XvCg`pBSPRITE[]̒ŎgĂB */
#define SPRITE_INIT2(name,texno,x,y,w,h,cx,cy,param) {(texno),(x),(y),(w),(h),(cx),(cy),(param)},

/*****************************************************************************
 *	gp
 *****************************************************************************/

typedef struct _SPRITE_DRIVER {
	RENDER* render;
	const SPRITE* sprites/*[sprite_count]*/;
	int sprite_count;
	TEXTURE* textures/*[texture_count]*/;
	int texture_count;
} SPRITE_DRIVER;

extern SPRITE_DRIVER sprite_driver;

/*****************************************************************************
 *	
 *****************************************************************************/

/* XvCghCo܂B
 * [in]
 *	render		`ɗp郌_[B
 *	sprites		XvCg`̐擪AhXB
 *	sprite_count	XvCg`̐B
 *	textures	eNX``̐擪AhXB
 *	texture_count	eNX``̐B
 */
void sprite_init(RENDER* render,
	const SPRITE* sprites/*[sprite_count]*/, int sprite_count,
	TEXTURE* textures/*[texture_count]*/, int texture_count);

/* XvCg`悵܂B
 * [in]
 *	x		XvCg_XWB
 *	y		XvCg_YWB
 *	sprno		XvCgԍB
 *	param		XvCg`paramXOR܂B
 *			Ⴆ΁AXvCg`paramDRW_REVXw肳ĂꍇA
 *			paramɂDRW_REVXw肷ƁAEĔ]ŕ`悵܂B
 * [note]
 *	* 炩sprite_init()ĂŁAXvCghCoĂĂB
 */
void sprite_draw(int x, int y, int sprno, int param);

/* gk]XvCg`悵܂B
 * [in]
 *	x		XvCg_XWB
 *	y		XvCg_YWB
 *	sprno		XvCgԍB
 *	param		XvCg`paramXOR܂B
 *			Ⴆ΁AXvCg`paramDRW_REVXw肳ĂꍇA
 *			paramɂDRW_REVXw肷ƁAEĔ]ŕ`悵܂B
 *	scale_x		g嗦B
 *	scale_y		cg嗦B
 *	rot		]pxB
 * [note]
 *	* 炩sprite_init()ĂŁAXvCghCoĂĂB
 */
void sprite_draw2(int x, int y, int sprno, int param, fixed scale_x, fixed scale_y, fixed rot);

#endif /*__CLIP_SPR_H__*/
